##parameters=styleprop=None, edit_mode=None, theme=None, REQUEST=None

tmtool = context.portal_themes 
mystyle = getattr(context, styleprop, None)

if mystyle is None:
   return

url = None
type = None
for obj in context.propertyMap():
   if obj['id'] == styleprop:
        type = obj.get('meta_type')

if type is None:
   return 

theme_container = tmtool.getThemeContainer(theme=theme)
mystyle_objs = theme_container.findStyles(mystyle)

if len(mystyle_objs) == 0:
   newstyle = theme_container.addPortalStyle(type_name=type)
   mystyle_objs = [newstyle]

oldstyle = mystyle_objs[0]

style = None
parents = oldstyle.findParents()

if len(parents) != 1:
   style = oldstyle.duplicate()
   context.manage_changeProperties({styleprop : style.getTitle()})
else:
   for s in tmtool.findStylesByContext(type, context)['object']:
      if s.getTitle() == mystyle:
         style = s

if style is not None:
   url = style.absolute_url() + '/edit_form?edit_mode=' + edit_mode + \
         '&style=' + type + '&theme=' + theme + '&cat=general' 

if REQUEST is not None and url is not None:
   REQUEST.RESPONSE.redirect(url)
